#include <stdio.h>
#include <string.h>
#include <machine/patmos.h>

#include "../inc/buffer_management.h"
#include "../library/buffer_management/mmio/tlsf.h"

int main(int argc, char **argv)
{

    buffer_management_config_t init_config;
    init_config.start_address = (void *) (PATMOS_IO_ETH + 0x0000);
    init_config.end_address = (void *) (PATMOS_IO_ETH + 0xF000);
    init_config.tlsf_cfg.sl_cls_cnt = 2;
    init_config.tlsf_cfg.fl_lowest_cls = 4;
    init_config.tlsf_cfg.fl_cls_cnt = 12;

    void * config_ptr = mmio_tlsf_init(&init_config);

    unsigned short  minimal_buffer = (1<<(init_config.tlsf_cfg.fl_lowest_cls ));
    void * buffer = mmio_tlsf_malloc(minimal_buffer, config_ptr);
    (void) mmio_tlsf_malloc(minimal_buffer, config_ptr);

    mmio_tlsf_memory_dump(config_ptr);
    mmio_tlsf_free(buffer, config_ptr);
    
    mmio_tlsf_memory_dump(config_ptr);

    
    //puts("Hello, World!");
    return 0;
}
