#ifndef LIBNETWORK_GENERIC_TYPES_H
#define LIBNETWORK_GENERIC_TYPES_H

// define generic types
typedef char int8_t;
typedef unsigned char uint8_t;
typedef short int16_t;
typedef unsigned short uint16_t;
typedef int int32_t;
typedef unsigned int uint32_t;
typedef long long int int64_t;
typedef unsigned long long int uint64_t;

typedef volatile uint8_t *  ptr_t;
typedef volatile uint8_t *  ptr_8_t;
typedef volatile uint16_t * ptr_16_t;
typedef volatile uint32_t * ptr_32_t;
typedef volatile uint64_t * ptr_64_t;

#ifdef ARCH_PATMOS

#include <machine/patmos.h>
// Specific types for io device pointers required buffer management and drivers#
// _IODEV macro sets the memory address space required by the compiler 
// newlib/libc/machine/patmos/machine/patmos.h : #define _IODEV __attribute__((address_space(1)))
typedef volatile _IODEV uint8_t *  mmio_ptr_t;
typedef volatile _IODEV uint8_t *  mmio_ptr_8_t;
typedef volatile _IODEV uint16_t * mmio_ptr_16_t;
typedef volatile _IODEV uint32_t * mmio_ptr_32_t;
typedef volatile _IODEV uint64_t * mmio_ptr_64_t;
#else
typedef volatile uint8_t *  mmio_ptr_t;
typedef volatile uint8_t *  mmio_ptr_8_t;
typedef volatile uint16_t * mmio_ptr_16_t;
typedef volatile uint32_t * mmio_ptr_32_t;
typedef volatile uint64_t * mmio_ptr_64_t;

#endif

#endif

