#ifndef _LIBNETWORK_SERVICES_TIME_SYNCHRONIATION_H_
#define _LIBNETWORK_SERVICES_TIME_SYNCHRONIATION_H_

#include "../net_types.h"
#include "../generic_types.h"
#include "../../library/services/time_synchronisation/ptp.h"


#ifndef TIME_SYNC_RCV_BUFFER_SIZE
    #define TIME_SYNC_RCV_BUFFER_SIZE 128
#endif

#ifndef TIME_SYNC_RCV_BUFFER_COUNT
    #define TIME_SYNC_RCV_BUFFER_COUNT 10
#endif 

#define TIME_SYNC_RCV_BUFFER_SPACE TIME_SYNC_RCV_BUFFER_SIZE * TIME_SYNC_RCV_BUFFER_COUNT

typedef enum
{
    TIME_SYNC_STATE_IDLE                                    =   0x0,
    TIME_SYNC_STATE_PDELAY_MEASUREMENT_REQUESTER            =   0x1,
    TIME_SYNC_STATE_PDELAY_MEASUREMENT_REQUESTER_FOLLOW_UP  =   0x2,
    TIME_SYNC_STATE_PDELAY_MEASUREMENT_RESPONDER            =   0x3,   
    TIME_SYNC_STATE_SYNC                                    =   0x4,
} time_sync_state_t;


typedef enum
{
    TIME_SYNC_FORCED_STATE_NONE =0,
    TIME_SYNC_FORCED_STATE_SLAVE =1,
} time_sync_forced_state_t;

typedef struct 
{
    uint16_t netw_if;

    uint8_t domainNumber;
    int8_t logSyncInterval;
    int8_t logSyncTimeout;

    int8_t logAnnounceInterval;
    uint8_t announceTimeout;

    int8_t logDelayReqInterval;
    int8_t logDelayRespTimeout;

    ptp_clock_accuracy_t clock_accuracy;

    time_sync_forced_state_t forced_state;
} time_synchronisation_config_t;


network_error_t time_synchronisation_init(time_synchronisation_config_t *conf);

network_error_t time_synchronisation_update(void);

void time_sync_get_runtime_data(time_interval_t *offfset, time_interval_t* mean_path_delay);

#endif
