import socket

def send_tcp_request(server_ip, server_port, request_text):
    try:
        # Create a socket object
        client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        
        # Connect to the server
        client_socket.connect((server_ip, server_port))
        
        # Send the request
        client_socket.send(request_text.encode())
        
        # Receive and print response
        response = client_socket.recv(1024)
        print("Response from server:", response.decode())
        
    except Exception as e:
        print("Error:", e)
    finally:
        client_socket.close()

if __name__ == "__main__":
    # Configure server IP, port, and request text
    server_ip = input("Enter server IP: ")
    server_port = int(input("Enter server port: "))
    request_text = input("Enter request text: ")
    
    # Send the request
    send_tcp_request(server_ip, server_port, request_text)
